#define FLOAT   0x80
#define BITS    0x10
#define PACKED  0x04

/* structure descripteur d'image versions <= 3*/
struct descripteur {
        short dimx;     /* dimension totale en x (=ndimx*ndimv) */
        short ndimy;    /* dimension en y */
        char bsize;     /* nb d'octets ou de bit par points */
	/* 1=uchar 2=short -1=char  */
        unsigned char flag;     /* octet de flag */
	/* 0= bsize en octet */
        short ndimz;    /* dimension en z */
        short ndimv;    /* dimension du vecteur (image vectorielle) */
        short ndimx;    /* nb de vecteurs par ligne */
        float maximum;  /* valeur du maximum */
        float minimum;  /* valeur du minimum */
        float moyenne;  /* valeur de la moyenne */
        short exposant; /* valeur de l'exposant */
        short float_typ;        /* type de flottant */
        int im_magic;   /* magic nb */
        int desc_ext;   /* taille d'extension du header : n*256, >= 0 */
        int x_off;      /* x offset */
        int y_off;      /* y offset */
        int z_off;      /* z offset */
        int maille;     /* 0 = rect, 1= hexa */
        float bias;   /* constante a rajouter a chaque pixel (virg. fixe) */
        float scale;  /* coeff multiplicatif (virg. fixe) quand il n'est pas 2**n
                       0 = a ignorer */
        char res[68];   /* reserve */
        char comment[128]; /* commentaire */
        } ;

#define IM3_MAGIC 0x49006e00
