#ifdef PIX_SHORT
  typedef short PIX;
# define PIX_MAX 32767
# define PIX_MIN -32767
#endif

#ifdef PIX_UCHAR
  typedef unsigned char PIX;
# define PIX_MAX  255
# define PIX_MIN  0
#endif

#include <math.h>
#include <stdio.h>

typedef double FLOAT;
typedef char DIRECTION;		/* pour les lacets (var.globales) */

/* ------------------------------image header */
     /* header for MorphoLisp, etc: frame included */
typedef struct image {
    int taillex, tailley;	/* allocated sizes of bitmap */
    int lup_x, lup_y;		/* window left-upper x,y */
    int size_x, size_y;		/* window sizes x,y */
    PIX *pixels;		/* pointer to pixels */
} Himage;

typedef struct mm0_image {
    int tx, ty;			/* allocated sizes of bitmap */
    int lx, ly;			/* window left-upper x,y */
    int sx, sy;			/* window sizes x,y */
    PIX *bitmap;		/* pointer to pixels */
} IMAGE;

/* ------------------------------------------------some constants */
#define RESULTAT_OK               0
/* macroes */

#define MAX(a, b)  ((a) > (b) ? (a) : (b))
#define MIN(a, b)  ((a) < (b) ? (a) : (b))

/* ----------------------------------------------macroes de test */

#define BASIC_CHECK(im) \
  ((im) == NULL) ? NULL_HEADER : \
  (((im)->bitmap == NULL) ? NULL_BITMAP : \
   ((((im)->tx < (im)->lx + (im)->sx)       \
     || ((im)->ty < (im)->ly + (im)->sy)) ? INCOHERENT_HEADER : \
    RESULTAT_OK))

#define SIZE_CHECK(im1,im2) \
  (((im1)->sx != (im2)->sx) || ((im1)->sy != (im2)->sy)) ? \
  IMAGE_NOT_SAME_SIZE : RESULTAT_OK

#define ALLOC_X_CHECK(im1,im2) \
  (((im1)->tx != (im2)->tx) ? X_ALLOC_DIFFERENT : RESULTAT_OK )
  
#define SET_SIZE(im1,im2) \
  ((((im2)->tx < (im1)->lx + (im1)->sx)       \
    || ((im2)->ty < (im1)->ly + (im1)->sy)) ? \
   IMAGE_TOO_SMALL : \
   ((im2)->lx = (im1)->lx, (im2)->ly = (im1)->ly, \
    (im2)->sx = (im1)->sx, (im2)->sy = (im1)->sy, RESULTAT_OK))

/* compute the PIX pointer to access pixels in image im */
#define BEG_PIXPTR(im) \
  (im->bitmap + im->lx + im->ly*im->tx)

/* ************** elements structurants ************************** */
struct element {

    char nbr_cpt_cnx;       /* nombre de composantes connexes */
    int  nbr_pix;           /* nombre de pixels qu'il contient */
    int  nbr_pix_dir[6];    /* nombre de pixels de contour dans chaque direction */
    int  *tab_a;            /* tableau des offsets de tous les pixels dans l'image */
    char *tab_a_r;          /* row's */
    int  *tab_dir[6];       /* tableau des offsets des pixels dans chaque direction */
    char *tab_dir_r[6];     /* rows */
    char flag_b;            /* contient-il son centre ? */
    int  *tab_cc;           /* un pixel de chaque composante connexe */
    char *tab_cc_r;
    char pc_r;              /* row of point central */
};

/************** scories ***********/
struct point {
	int x;
	int y;
};

#include "cg_errno.h"

/*********Morpho avancee ********/

# define  NB_BOUCLES   12000L
# define  NB_DIRECTION 120000L
/*
# include "lacet.h"
*/
# define echange(a,b,c) temp = a; a = b; b = c; c = temp;

 /* les variables globales du systeme */
/*
# define EXTERN extern
# include "morpho-dat.h" */

/*
# include "lcr_errno.h"
*/

/*
#ifndef ALLEGORY
# define LCR_ERROR(code, f_name ) (void) lcr_error(code, f_name)
# define ADJRESULT(code)    	()
#else
# define LCR_ERROR(code, f_name) return -(code)
# define ADJRESULT(code)    	(ipl_errno = code = ( code <0) ? - code | E_LCR2: code);
# define LCRECODE(code)    	(ipl_errno = (code | E_LCR2))
#endif
*/


struct lacet {
    struct point origine;
    DIRECTION *liste;
    int longueur;
    int valeur;
    int type;
};


typedef struct glace {
   DIRECTION    *chain1, *chain2, *pt, *pt1, *pt2;
   struct lacet *loop1, *loop2;
   DIRECTION dir;
   int xx, yy, imavide;
} GLACE;

/*********Definition de toutes les fonction ******/
#include "morpho_defs.h"

