/* les define classiques */
/*************************/

/* image logical & arithmetic comparisons */
#define CG_ADD	1	/* addition */
#define CG_SUB	2	/* subtraction */
#define CG_MUL	3	/* multiplication */
#define CG_DIV	4	/* division */
#define CG_AND	5	/* logical and */
#define CG_OR	6	/* logical or */
#define CG_XOR	7	/* exclusive or */
#define CG_ANDNOT 8	/* dif        *pt_out = *pt_in1 & (1 -  *pt_in2); */
#define CG_MAX	9	/* *pt_out = (*pt_in1 > *pt_in2) ? *pt_in1 : *pt_in2; */
#define CG_MIN	10	/* *pt_out = (*pt_in1 < *pt_in2) ? *pt_in1 : *pt_in2; */
/* image comparisons */
#define CG_LT	1	/* *pt_out = (*pt_in1 < pix_in2)  ? 1 : 0; */
#define CG_LE	2	/* *pt_out = (*pt_in1 <= pix_in2) ? 1 : 0; */
#define CG_EQ	3	/* *pt_out = (*pt_in1 == pix_in2) ? 1 : 0; */
#define CG_NEQ	4	/* *pt_out = (*pt_in1 != pix_in2) ? 1 : 0; */
#define CG_GE	5	/* *pt_out = (*pt_in1 >= pix_in2) ? 1 : 0; */
#define CG_GT	6	/* *pt_out = (*pt_in1 >  pix_in2) ? 1 : 0; */

/* les routines d'erreur */
/*************************/
extern void terror (int, char *, char *);
extern void killer ();
extern char * e_cg (int);
extern int cg_error (int, char *);

/* Initialisation */
/******************/
extern IMAGE ** init_all_images (int, int, int);
extern IMAGE * mm0_alloc_image (int, int, int, int, int, int);
extern IMAGE * mm0_alloc_header ();
extern int mm0_alloc_bitmap (IMAGE *, int, int);
extern int mm0_free_bitmap (IMAGE *);
extern int mm0_print_caract (IMAGE *);
extern int mm0_modif_caract (IMAGE *, int, int, int, int);
extern void mm0_reset_lacet();
extern void mm0_free_lacet();
extern GLACE *mm0_alloc_lacet (long, long);
extern GLACE *mm0_alloc_chains (IMAGE *);
extern void mm0_recri_dil (GLACE *);
extern int mm0_depla (GLACE *, IMAGE *);
extern void mm0_xynew (GLACE *);
extern void mm0_dil_chaine (GLACE *);
extern void mm0_adjust_masque (IMAGE *, GLACE *, int, int);
extern void mm0_adjust_fond (IMAGE *, GLACE *, int, int);
extern int mm0_front (IMAGE *, GLACE *, int, int, int, struct lacet *, DIRECTION *);
extern int mm0_front_e (IMAGE *, GLACE *, int, int, int, struct lacet *, DIRECTION *);
extern void mm0_copy_chaine (GLACE *, int, int);
extern void mm0_trace_chaine (IMAGE *, GLACE *, int, struct lacet *);
extern void mm0_trace_masque (IMAGE *, GLACE *, int, int, int);
extern void mm0_debut_chaine (GLACE *, struct lacet *);
extern int mm0_cont (IMAGE *, GLACE *);
extern int mm0_cont_e (IMAGE *, GLACE *);
extern void mm0_recri_dil_conj (GLACE *);
extern int mm0_dil_chaine_conj (GLACE *);
extern int mm0_sens (struct lacet *, GLACE *);
extern void set_all_headers (IMAGE **, int, IMAGE *);
extern void set_header (IMAGE *, IMAGE *);

/* visualisation */
/*****************/
extern void voir_inr_image (IMAGE *, char *, char *);

/* entrees-sorties */
/*******************/
extern int mm0_imagin (IMAGE *, char *);
extern int mm0_imaout (IMAGE *, char *);
extern int mm0_imagin_ppm (IMAGE *, char *);
extern int mm0_imagin_pgm_ascii (IMAGE *, char *);
extern int mm0_imagin_pgm_c (IMAGE *, char *);
extern int mm0_imagin_pgm_cc (IMAGE *, IMAGE *, IMAGE *, char *);
extern int mm0_imaout_pgm_cc (IMAGE *, IMAGE *, IMAGE *, char *);
extern int mm0_imagin_enst (IMAGE *, char *);
extern int mm0_imaout_enst (IMAGE *, char *);

/* operations algebriques et manipulation */
/******************************************/
extern int mm0_set (IMAGE *, int);
extern int mm0_copy (IMAGE *, IMAGE *);
extern int mm0_point (IMAGE *, int, int, int);
extern int mm0_lire (IMAGE *, int, int, int *);
extern int mm0_add (IMAGE *, IMAGE *, IMAGE *);
extern int mm0_sub (IMAGE *, IMAGE *, IMAGE *);
extern int mm0_mul (IMAGE *, IMAGE *, IMAGE *);
extern int mm0_div (IMAGE *, IMAGE *, IMAGE *);
extern int mm0_and (IMAGE *, IMAGE *, IMAGE *);
extern int mm0_or  (IMAGE *, IMAGE *, IMAGE *);
extern int mm0_xor (IMAGE *, IMAGE *, IMAGE *);
extern int mm0_andnot (IMAGE *, IMAGE *, IMAGE *);
extern int mm0_max (IMAGE *, IMAGE *, IMAGE *);
extern int mm0_min (IMAGE *, IMAGE *, IMAGE *);
extern int mm0_algebre (IMAGE *, IMAGE *, IMAGE *, int);
extern int mm0_cadd (IMAGE *, int, IMAGE *);
extern int mm0_csub (IMAGE *, int, IMAGE *);
extern int mm0_cmul (IMAGE *, int, IMAGE *);
extern int mm0_cdiv (IMAGE *, int, IMAGE *);
extern int mm0_cand (IMAGE *, int, IMAGE *);
extern int mm0_cor  (IMAGE *, int, IMAGE *);
extern int mm0_cxor (IMAGE *, int, IMAGE *);
extern int mm0_candnot (IMAGE *, int, IMAGE *);
extern int mm0_cmax (IMAGE *, int, IMAGE *);
extern int mm0_cmin (IMAGE *, int, IMAGE *);
extern int mm0_calgebre (IMAGE *, int, IMAGE *, int);
extern int mm0_clt (IMAGE *, int, IMAGE *);
extern int mm0_cle (IMAGE *, int, IMAGE *);
extern int mm0_ceq (IMAGE *, int, IMAGE *);
extern int mm0_cneq (IMAGE *, int, IMAGE *);
extern int mm0_cge (IMAGE *, int, IMAGE *);
extern int mm0_cgt (IMAGE *, int, IMAGE *);
extern int mm0_ccomp (IMAGE *, int, IMAGE *, int);
extern int mm0_lt (IMAGE *, IMAGE *, IMAGE *);
extern int mm0_le (IMAGE *, IMAGE *, IMAGE *);
extern int mm0_eq (IMAGE *, IMAGE *, IMAGE *);
extern int mm0_neq (IMAGE *, IMAGE *, IMAGE *);
extern int mm0_ge (IMAGE *, IMAGE *, IMAGE *);
extern int mm0_gt (IMAGE *, IMAGE *, IMAGE *);
extern int mm0_imcomp (IMAGE *, IMAGE *, IMAGE *, int);
extern int mm0_thresh (IMAGE *, IMAGE *, int, int);
extern int mm0_cadre (IMAGE *, int);
extern int mm0_inner_frame (IMAGE *, IMAGE *, int, int);
extern int mm0_cadre_int (IMAGE *, int);

/* 4 operations par un hexagone */
/********************************/
extern int mm0_dilate (IMAGE *, IMAGE *, IMAGE *, int);
extern int mm0_erode (IMAGE *, IMAGE *, IMAGE *, int);
extern int mm0_open (IMAGE *, IMAGE *, IMAGE *, int);
extern int mm0_close (IMAGE *, IMAGE *, IMAGE *, int);
extern int mm0_bin_dilate (IMAGE *, IMAGE *, int, int);
extern int mm0_bin_erode (IMAGE *, IMAGE *, int, int);
extern int mm0_bin_open (IMAGE *, IMAGE *, int, int);
extern int mm0_bin_close (IMAGE *, IMAGE *, int, int);
extern int mm0_sucero (IMAGE *, IMAGE *, int);
extern int mm0_distance_hexa (IMAGE *);
extern int mm0_distance_dodeca (IMAGE *);
extern int mm0_distance_geod (IMAGE *, IMAGE *);

/* 4 operations par un segment */
/********************************/
extern int mm0_lin_dilate (IMAGE *, IMAGE *, int, int, int);
extern int mm0_lin_erode (IMAGE *, IMAGE *, int, int, int);
extern int mm0_lin_open (IMAGE *, IMAGE *, int, int, int);
extern int mm0_lin_close (IMAGE *, IMAGE *, int, int, int);

/* 4 operations par un dodecagone */
/**********************************/
extern int mm0_dodeca_dilate (IMAGE *, int);
extern int mm0_dodeca_erode (IMAGE *, int);
extern int mm0_dodeca_open (IMAGE *, int);
extern int mm0_dodeca_close (IMAGE *, int);

/* dilatation et erosion geodesique */
/************************************/
extern int mm0_num_dil_geod (IMAGE *, IMAGE *, int);
extern int mm0_num_ero_geod (IMAGE *, IMAGE *, int);
extern int mm0_recons (IMAGE *, IMAGE *);
extern int mm0_label (IMAGE *);
extern int mm0_hole (IMAGE *, IMAGE *);
extern int mm0_holefill (IMAGE *, IMAGE *);

/* LPE */
/*******/
extern int mm0_lpe1 (IMAGE *, IMAGE *);

/* propagation */
/***************/
extern int mm0_propagation (IMAGE *, IMAGE *);
extern int mm0_propagation_dodeca (IMAGE *, IMAGE *);

/* maxima regionaux */
/********************/
extern int mm0_reg_max (IMAGE *, IMAGE *);
extern int mm0_reg_min (IMAGE *, IMAGE *);
extern int mm0_reg_minmax (IMAGE *, IMAGE *, int);

/* squelettes */
/**************/
extern int mm0_squ1 (IMAGE *, IMAGE *);
extern int mm0_squ2 (IMAGE *, IMAGE *, int);
extern int mm0_skiz (IMAGE *, IMAGE *);
extern int mm0_hmtstruct (IMAGE *, IMAGE *, int *, int, int *);
extern int mm0_hmtbin (IMAGE *, IMAGE *, int *, int, int, int);
extern int mm0_hmtlut (IMAGE *, IMAGE *, PIX *, int, int *);
extern int mm0_endpnt (IMAGE *, IMAGE *);
extern int mm0_tripnt (IMAGE *, IMAGE *);
extern int mm0_prune (IMAGE *, IMAGE *, int);
extern int mm0_squelette (IMAGE *, IMAGE *);
extern void cg_fillut (int *, PIX *, int);
extern void cg_rotation (int *);
extern void mm0_readim (IMAGE *, int, PIX*);
extern void mm0_writim (IMAGE *, int, PIX*);
extern void mm0_free_lbuf();
extern PIX ** mm0_alloc_lbuf (IMAGE *);

/* convexite */
/*************/
extern int mm0_convexe_fort (IMAGE *);
extern int mm0_convexe_faible (IMAGE *);

/* mesures */
/***********/
extern int mm0_minim (IMAGE *, int *);
extern int mm0_maxim (IMAGE *, int *);
extern int mm0_euler (IMAGE *, int *);
extern int mm0_count_objects (IMAGE *, int *);
extern int mm0_perimetre (IMAGE *, int *);
extern int mm0_area (IMAGE *, int *);
extern int mm0_histo (IMAGE *, int, int, int *);
extern int mm0_compter (IMAGE *, int, long *, int);
