#include "morpho.h"
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <malloc.h>


/* ! THIS ROUTINE must not be called by user codes !!*/
/*****************************************************/
/* regles de reecriture pour l'hexagone de taille un */
/*****************************************************/

void mm0_recri_dil_4 (cgl)
     GLACE *cgl;
{
  int dif;

  dif = (*cgl->pt2 - *cgl->pt1); if (dif < 0) dif += 4;
  switch (dif)
    {
    case 0 : break;
    case 1 : *cgl->pt++ = *cgl->pt2;
      *cgl->pt++ = *cgl->pt1;
      break;
    case 2 : *cgl->pt++ = (*cgl->pt1 < 3) ? *cgl->pt1 + 1 : *cgl->pt1 - 3;
      *cgl->pt++ = *cgl->pt1;
      *cgl->pt++ = *cgl->pt2;
      *cgl->pt++ = (*cgl->pt1 < 3) ? *cgl->pt1 + 1 : *cgl->pt1 - 3;
      break;
    case 3 : *cgl->pt++ = (*cgl->pt1 < 3) ? *cgl->pt1 + 1 : *cgl->pt1 - 3;
      *cgl->pt++ = (*cgl->pt1 < 2) ? *cgl->pt1 + 2 : *cgl->pt1 - 2;
      break;
    }
}

void mm0_recri_dil_8 (cgl)
     GLACE *cgl;
{
  int dif;

  dif = (*cgl->pt2 - *cgl->pt1); if (dif < 0) dif += 4;
  switch (dif)
    {
    case 0 : break;
    case 1 : *cgl->pt++ = *cgl->pt1;
      *cgl->pt++ = *cgl->pt2;
      break;
    case 2 : *cgl->pt++ = *cgl->pt1;
      *cgl->pt++ = (*cgl->pt1 < 3) ? *cgl->pt1 + 1 : *cgl->pt1 - 3;
      *cgl->pt++ = (*cgl->pt1 < 3) ? *cgl->pt1 + 1 : *cgl->pt1 - 3;
      *cgl->pt++ = *cgl->pt2;
      break;
    case 3 : *cgl->pt++ = (*cgl->pt1 < 3) ? *cgl->pt1 + 1 : *cgl->pt1 - 3;
      *cgl->pt++ = (*cgl->pt1 < 2) ? *cgl->pt1 + 2 : *cgl->pt1 - 2;
      break;
    }
}

/* ! THIS ROUTINE must not be called by user codes !!*/
/* CHECKED */
int mm0_depla_4 (cgl, image)
     GLACE *cgl;
     IMAGE *image;
{
    
  /***************************************************************/
  /* calcule la difference d'adresse dans la direction cgl->dir */
  /* on utilise les variables cgl->xx et cgl->yy donnant       */
  /* la position du point courrant                               */
  /***************************************************************/
    
  switch (cgl->dir) {
  case 0 : return (1); break;
  case 1 : return (image->tx); break;
  case 2 : return (-1); break;
  case 3 : return (-image->tx); break;
  }
  printf (" ** Horreur dans depla\n");
  abort();			/* never used: trap it! */
}

/* ! THIS ROUTINE must not be called by user codes !!*/
/* CHECKED */
void mm0_xynew_4 ( cgl)
     GLACE *cgl;
{

  /***************************************************************/
  /* met a jour la position courrante cgl->xx et cgl->yy quand on  */
  /* on se deplace dans la direction cgl->dir                     */
  /***************************************************************/

  switch (cgl->dir) {
  case 0 : cgl->xx++; break;
  case 1 : cgl->yy++; break;
  case 2 : cgl->xx--; break;
  case 3 : cgl->yy--; break;
  default : printf (" ** Horreur dans xynew\n");
  }
}

/* ! THIS ROUTINE must not be called by user codes !!*/
/*****************************************************/
/* dilatation par un hexagone de taille un de toutes */
/* les chaines de cg_loop1 dans cg_loop2           */
/* cg_loop1 et cg_chain1 restent intacts           */
/*****************************************************/

void mm0_dil_chaine_4 (cgl)
     GLACE *cgl;
{
  struct lacet *boucle1, *boucle2;
  int i;

  boucle1 = cgl->loop1;
  boucle2 = cgl->loop2;
  cgl->pt = cgl->chain2;

  while (boucle1->liste != 0) {

    /* cas du point isole */

    if (boucle1->longueur == 0) {
      boucle2->origine.x = boucle1->origine.x + 1;
      boucle2->origine.y = boucle1->origine.y;
      boucle2->valeur = boucle1->valeur;
      boucle2->liste = cgl->pt;
      boucle2->longueur = 8;
      boucle2->type = 1;
      *cgl->pt++ = 2; *cgl->pt++ = 1; *cgl->pt++ = 3; *cgl->pt++ = 2; 
      *cgl->pt++ = 0; *cgl->pt++ = 3; *cgl->pt++ = 1; *cgl->pt++ = 0;
    } else {
      boucle2->liste = cgl->pt; boucle2->type = boucle1->type;
      boucle2->valeur = boucle1->valeur;
      if (boucle1->type == 1) {

	/* cas du lacet qui ne doit pas arriver !! */

	cgl->pt1 = boucle1->liste + boucle1->longueur - 1;
	cgl->pt2 = boucle1->liste;
	cgl->xx = boucle1->origine.x;
	cgl->yy = boucle1->origine.y;
	/*cgl->dir = (*cgl->pt1 < 2) ? *cgl->pt1 + 4 : *cgl->pt1 - 2; */
	cgl->dir = *cgl->pt1 - 1; if (cgl->dir<0) cgl->dir += 4;
	mm0_xynew_4 (cgl);
	boucle2->origine.x = cgl->xx;
	boucle2->origine.y = cgl->yy;
	for (i = 0; i < boucle1->longueur; i++) {
	  mm0_recri_dil_4 (cgl);
	  *cgl->pt++ = *cgl->pt2;
	  cgl->pt1 = cgl->pt2; cgl->pt2++;
	}
      } else {

	/* cas general d'une chaine non vide */

	cgl->pt1 = boucle1->liste;
	cgl->pt2 = boucle1->liste + 1;
	boucle2->origine.x = boucle1->origine.x;
	boucle2->origine.y = boucle1->origine.y;
	*cgl->pt++ = (*cgl->pt1 < 1) ? *cgl->pt1 + 3 : *cgl->pt1 - 1;
	*cgl->pt++ = *cgl->pt1;
	for (i =0; i < boucle1->longueur - 1; i++) {
	  mm0_recri_dil_4 (cgl);
	  *cgl->pt++ = *cgl->pt2;
	  cgl->pt1 = cgl->pt2; cgl->pt2++;
	}
	*cgl->pt++ = (*cgl->pt1 < 3) ? *cgl->pt1 + 1 : *cgl->pt1 - 3;
      }
    }
    boucle2->longueur = cgl->pt - boucle2->liste;
    boucle2++; boucle1++;
  }
  boucle2->liste = 0;
}

void mm0_dil_chaine_8 (cgl)
     GLACE *cgl;
{
  struct lacet *boucle1, *boucle2;
  int i;

  boucle1 = cgl->loop1;
  boucle2 = cgl->loop2;
  cgl->pt = cgl->chain2;

  while (boucle1->liste != 0) {

    /* cas du point isole */

    if (boucle1->longueur == 0) {
      boucle2->origine.x = boucle1->origine.x + 1;
      boucle2->origine.y = boucle1->origine.y;
      boucle2->valeur = boucle1->valeur;
      boucle2->liste = cgl->pt;
      boucle2->longueur = 8;
      boucle2->type = 1;
      *cgl->pt++ = 1; *cgl->pt++ = 2; *cgl->pt++ = 2; *cgl->pt++ = 3; 
      *cgl->pt++ = 3; *cgl->pt++ = 0; *cgl->pt++ = 0; *cgl->pt++ = 1;
    } else {
      boucle2->liste = cgl->pt; boucle2->type = boucle1->type;
      boucle2->valeur = boucle1->valeur;
      if (boucle1->type == 1) {

	/* cas du lacet qui ne doit pas arriver !! */

	cgl->pt1 = boucle1->liste + boucle1->longueur - 1;
	cgl->pt2 = boucle1->liste;
	cgl->xx = boucle1->origine.x;
	cgl->yy = boucle1->origine.y;
	/*cgl->dir = (*cgl->pt1 < 2) ? *cgl->pt1 + 4 : *cgl->pt1 - 2; */
	cgl->dir = *cgl->pt1 - 1; if (cgl->dir<0) cgl->dir += 4;
	mm0_xynew_4 (cgl);
	boucle2->origine.x = cgl->xx;
	boucle2->origine.y = cgl->yy;
	for (i = 0; i < boucle1->longueur; i++) {
	  mm0_recri_dil_8 (cgl);
	  *cgl->pt++ = *cgl->pt2;
	  cgl->pt1 = cgl->pt2; cgl->pt2++;
	}
      } else {

	/* cas general d'une chaine non vide */

	cgl->pt1 = boucle1->liste;
	cgl->pt2 = boucle1->liste + 1;
	boucle2->origine.x = boucle1->origine.x;
	boucle2->origine.y = boucle1->origine.y;
	*cgl->pt++ = (*cgl->pt1 < 1) ? *cgl->pt1 + 3 : *cgl->pt1 - 1;
	*cgl->pt++ = *cgl->pt1;
	for (i =0; i < boucle1->longueur - 1; i++) {
	  mm0_recri_dil_8 (cgl);
	  *cgl->pt++ = *cgl->pt2;
	  cgl->pt1 = cgl->pt2; cgl->pt2++;
	}
	*cgl->pt++ = (*cgl->pt1 < 3) ? *cgl->pt1 + 1 : *cgl->pt1 - 3;
      }
    }
    boucle2->longueur = cgl->pt - boucle2->liste;
    boucle2++; boucle1++;
  }
  boucle2->liste = 0;
}

/*******************************************************/
/* ajustement des chaines et lacets de cg_loop2       */
/* resultat dans cg_loop1                             */
/* im : image contenant le masque de propagation       */
/* val_trace : tous les lacets et chaines sont traces  */
/*       a la valeur val_trace                         */
/* val_masque : seules les portions de chaines qui se  */
/*       trouvaient sur des pixels a cette valeur sont */
/* conservees.                                         */
/*******************************************************/

void mm0_adjust_masque_4 (image, cgl, val_trace, val_masque)
     IMAGE *image;
     GLACE *cgl;
     int val_trace, val_masque;
{
  struct lacet *bouc1, *bouc2;
  PIX c, *lecture;
  DIRECTION *ptend, *ptold, *pt1_temp, *pt2_temp;

  /* input checks are suppressed: they should have been done
   * by the caller. This routine is PRIVATE and is called
   * from routines having already checked their input
   */
    
  bouc2 = cgl->loop2; bouc1 = cgl->loop1;
  cgl->pt2 = cgl->chain2; cgl->pt1 = cgl->chain1;
  cgl->imavide = 1;
  
  while (bouc2->liste != 0) {
    ptend = bouc2->liste + bouc2->longueur;
    cgl->xx = bouc2->origine.x; cgl->yy = bouc2->origine.y;
    lecture = image->bitmap + cgl->xx + cgl->yy*image->tx;
    c = (val_trace < 0) ? bouc2->valeur : val_trace;
    /* printf ("[adjm:%d]", c); fflush (stdout); */
    cgl->pt2 = bouc2->liste;
    if (bouc2->type == 1) {
      
      /* cas d'un lacet */
      
      while (cgl->pt2 < ptend) {
	if (*lecture != val_masque) {
	  /* rotation du lacet -> chaine */
	  pt2_temp = bouc2->liste; pt1_temp = cgl->pt1;
	  while (pt2_temp < cgl->pt2) *pt1_temp++ = *pt2_temp++;
	  pt1_temp = bouc2->liste;
	  while (pt2_temp < ptend) *pt1_temp++ = *pt2_temp++;
	  pt2_temp = cgl->pt1;
	  while (pt1_temp < ptend) *pt1_temp++ = *pt2_temp++;
	  bouc2->origine.x = cgl->xx; bouc2->origine.y = cgl->yy;
	  bouc2->type = 0; break;
	}
	cgl->dir = *cgl->pt2++;
	lecture += mm0_depla_4 (cgl,image); mm0_xynew_4 (cgl);
      }
      if (bouc2->type == 1) {
	/* si lacet -> recopie et trace */
	cgl->xx = bouc1->origine.x = bouc2->origine.x;
	cgl->yy = bouc1->origine.y = bouc2->origine.y;
	bouc1->longueur = bouc2->longueur;
	bouc1->valeur = bouc2->valeur;
	bouc1->type = 1; bouc1->liste = cgl->pt1;
	lecture = image->bitmap + cgl->xx + cgl->yy*image->tx;
	*lecture = c; /* corrige le 24/4/98 */
	for(cgl->pt2 = bouc2->liste; cgl->pt2 < ptend;) {
	  cgl->dir = *cgl->pt2; 
	  lecture += mm0_depla_4 (cgl, image);
	  *lecture = c; mm0_xynew_4 (cgl);
	  *cgl->pt1++ = *cgl->pt2++;
	}
	bouc2++; bouc1++; cgl->imavide = 0;
      }
    } else {
      
      /* cas de la chaine */
      
      for (;;) {
	cgl->dir = *cgl->pt2;
	/* recherche de debut de chaine */
	while(cgl->pt2 < 
	      ptend && *(lecture += mm0_depla_4 (cgl,image)) != val_masque) {
	  mm0_xynew_4 (cgl); cgl->pt2++; cgl->dir = *cgl->pt2;
	}
	bouc1->longueur = 0;
	if (cgl->pt2 == ptend) break;
	*lecture = c;
	bouc1->origine.x = cgl->xx; bouc1->origine.y = cgl->yy;
	bouc1->type = 0; bouc1->liste = cgl->pt1;
	ptold = cgl->pt2; mm0_xynew_4 (cgl); *cgl->pt1++ = *cgl->pt2++;
	cgl->dir = *cgl->pt2;
	/* suivi de la chaine nouvelle */
	while(cgl->pt2 < ptend &&
	      *(lecture += mm0_depla_4(cgl,image)) == val_masque) {
	  *cgl->pt1++ = *cgl->pt2; *lecture = c;
	  mm0_xynew_4 (cgl); cgl->pt2++; cgl->dir = *cgl->pt2;
	}
	mm0_xynew_4(cgl); *cgl->pt1++ = *cgl->pt2++;
	bouc1->valeur = bouc2->valeur;
	bouc1->longueur = cgl->pt2 - ptold; bouc1++;
	cgl->imavide = 0;
	if (cgl->pt2 == ptend) break;
      }
      bouc2++;
    }
  }
  bouc1->liste = 0;
}

/* CHECKED */
int mm0_front_4_old (image, cgl, lx, ly, dirdep, boucle, ptdep)
     IMAGE     *image;
     int       lx, ly, dirdep;
     GLACE     *cgl;
     DIRECTION *ptdep;
     struct lacet *boucle;
{
/********************************************************************/
/*    suivi d'une seule frontiere = une seule chaine                */
/*    im      : image de l'ensemble (fond = 0, forme = 1)           */
/*    lx,ly   : point de depart du suivi                            */
/*    dirdep  : direction de depart. Le point dans cette direction  */
/*              a partir de lx, ly doit etre dans le fond           */
/*    boucle  : entete de chaine ou stocker le resultat             */
/*    ptdep   : endroit ou stocker les directions                   */
/* !! im est modifiee : fond  = 0 ou 2 (erode du fond = 0)          */
/*                      forme = 1 ou 3 (erode de la forme = 3)      */
/* !! si le contour suivi est reduit a un point la chaine a une     */
/*    longueur 0                                                    */
/********************************************************************/

  PIX *debut, *adr;	 /* apparently not initialised */
			 /* but algorithm garantees not used before set */
  cgl->pt1 = ptdep;
  cgl->xx = lx;
  cgl->yy = ly;
  cgl->dir = dirdep;
  debut = image->bitmap + cgl->xx + (cgl->yy)*(image->tx);

  while (1) {
    if ((cgl->xx != lx) || (cgl->yy != ly)) {
      /* cas du point general */
      do {
	if (++cgl->dir > 3) cgl->dir -= 4;
	if (debut != adr) *adr = 2;
      } while (!(*(adr = debut + mm0_depla_4 (cgl, image)) & 1));
    } else {
      /* cas du point de depart */
      if ((++cgl->dir) > 3) cgl->dir -= 4;
      while (!(*(adr = debut + mm0_depla_4 (cgl, image)) & 1)) {
	*adr = 2;
	if (cgl->dir == dirdep) {
	  /* fin de l'algorithme */
	  boucle->longueur = cgl->pt1 - ptdep;
	  boucle->origine.x = lx; boucle->origine.y = ly;
	  boucle->liste = ptdep; boucle->type = 1;
	  *debut = 3;
	  return (RESULTAT_OK);
	}
	if (++cgl->dir > 3) cgl->dir -= 4;
      }
    }
    debut = adr;
    *cgl->pt1++ = cgl->dir;
    mm0_xynew_4 (cgl);
    *debut = 3; cgl->dir += 2;
  }
}

/**************************************************************/
/* suivi de tous les contours de l'image im                   */
/* les chaines sont stockees dans cgl->loop1 et cgl->chain1 */
/* im : fond = 0, forme = 1                                   */
/* !! l'image im est modifiee par front.c                     */
/**************************************************************/
/* CHECKED */
int mm0_cont_4 (image, cgl)
     IMAGE *image;
     GLACE *cgl;
{
    
  DIRECTION *ptdep;
  struct lacet *boucle;
  PIX    *pt_im, *pt_im_old;
  int xmin, xmax, ymin, ymax;
  int x, y, ret;
    
  ret = mm0_cadre (image, 0);
  if(ret!=RESULTAT_OK) return(ret);

  xmin = image->lx - 1;
  xmax = xmin + image->sx + 2;
  ymin = image->ly;
  ymax = ymin + image->sy;
  pt_im = image->bitmap + xmin + ymin*image->tx;
  boucle = cgl->loop1;
  ptdep = cgl->chain1;
    
  for (y = ymin; y < ymax; y++) {
    pt_im_old = pt_im;
    for (x = xmin; x < xmax - 1; x++, pt_im++) {
      if((*pt_im == 0 && (*(pt_im + 1) & 1))
	 || (!(*pt_im & 1) && *(pt_im + 1) == 1)) {
	mm0_front_4 (image, cgl, x + 1, y, 2, boucle, ptdep);
	ptdep += boucle->longueur;
	boucle++;
      }
    }
    pt_im = pt_im_old + image->tx;
  }
  
  boucle->liste = 0;
  (void) mm0_calgebre (image, 1, image, CG_AND);
  return (RESULTAT_OK);
}

int mm0_distance_4 (inout)
     IMAGE *inout;
{
  int dist = 1;
  int ret;
  GLACE  *cgl, *mm0_alloc_chains();

  cgl=mm0_alloc_chains (inout);
  if(cgl==NULL) return(LACET_ALLOC_FAILED);

  ret=mm0_cont_4 (inout, cgl);
  if(ret!=RESULTAT_OK) return(ret);

  (void)mm0_cadre (inout, 1);

  cgl->imavide = 0;

  while (cgl->imavide == 0) {
    mm0_dil_chaine_4 (cgl);
    mm0_adjust_masque_4 (inout, cgl, ++dist, 0);
  }

  return (RESULTAT_OK);
}

int mm0_distance_8 (inout)
     IMAGE *inout;
{
  int dist = 1;
  int ret;
  GLACE  *cgl, *mm0_alloc_chains();

  cgl=mm0_alloc_chains (inout);
  if(cgl==NULL) return(LACET_ALLOC_FAILED);

  ret=mm0_cont_4 (inout, cgl);
  if(ret!=RESULTAT_OK) return(ret);

  (void)mm0_cadre (inout, 1);

  cgl->imavide = 0;

  while (cgl->imavide == 0) {
    mm0_dil_chaine_8 (cgl);
    mm0_adjust_masque_4 (inout, cgl, ++dist, 0);
  }

  return (RESULTAT_OK);
}

int mm0_distance_geod_4 (inout, mask)
     IMAGE *inout, *mask;
{

  int dist = 3;
  int ret;
  GLACE *cgl, *mm0_alloc_chains();

  cgl=mm0_alloc_chains (inout);
  if(cgl==NULL) return(LACET_ALLOC_FAILED);

  ret=mm0_cont_4 (inout, cgl);
  if(ret!=RESULTAT_OK) return(ret);

  ret=mm0_algebre (inout, mask, inout, CG_ADD);
  if(ret!=RESULTAT_OK) return(ret);

  (void)mm0_cadre (inout, 0);

  cgl->imavide = 0;
  while (cgl->imavide == 0) {
    mm0_dil_chaine_4 (cgl);
    mm0_adjust_masque_4 (inout, cgl, ++dist, 1);
  }

  return (RESULTAT_OK);
}

int mm0_distance_geod_8 (inout, mask)
     IMAGE *inout, *mask;
{

  int dist = 3;
  int ret;
  GLACE *cgl, *mm0_alloc_chains();

  cgl=mm0_alloc_chains (inout);
  if(cgl==NULL) return(LACET_ALLOC_FAILED);
  
  ret=mm0_cont_4 (inout, cgl);
  if(ret!=RESULTAT_OK) return(ret);
  
  ret=mm0_algebre (inout, mask, inout, CG_ADD);
  if(ret!=RESULTAT_OK) return(ret);

  (void)mm0_cadre (inout, 0);
  cgl->imavide = 0;
  while (cgl->imavide == 0) {
    mm0_dil_chaine_8 (cgl);
    mm0_adjust_masque_4 (inout, cgl, ++dist, 1);
  }

  return (RESULTAT_OK);
}

int mm0_front_4 (image, cgl, lx, ly, dirdep, boucle, ptdep)
     IMAGE     *image;
     int       lx, ly, dirdep;
     GLACE     *cgl;
     DIRECTION *ptdep;
     struct lacet *boucle;
{
    PIX *debut, *adr;

    cgl->pt1 = ptdep;
    cgl->xx = lx;
    cgl->yy = ly;
    cgl->dir = dirdep;
    debut = image->bitmap + cgl->xx + (cgl->yy)*(image->tx);
    *debut = 3; *(debut + mm0_depla_4 (cgl, image)) = 2;
    if (++cgl->dir > 3) cgl->dir -= 4;

    while (1) {
      if ((cgl->xx != lx) || (cgl->yy != ly)) {
	/* cas du point general */
	while (!(*(adr = debut + mm0_depla_4 (cgl, image)) & 1)) {
	  *adr = 2;
	  if (++cgl->dir > 3) cgl->dir -= 4;
	}

      } else {

	/* cas du point de depart */
	while (!(*(adr = debut + mm0_depla_4 (cgl, image)) & 1)) {
	  if (cgl->dir == dirdep) {
	    /* fin de l'algorithme */
	    boucle->longueur = cgl->pt1 - ptdep;
	    boucle->origine.x = lx; boucle->origine.y = ly;
	    boucle->liste = ptdep; boucle->type = 1;
	    /* *debut = 3; */
	    return (RESULTAT_OK);
	  }
	  *adr = 2;
	  if (++cgl->dir > 3) cgl->dir -= 4;
	}
      }
      debut = adr;
      *cgl->pt1++ = cgl->dir;
      mm0_xynew_4 (cgl);
      *debut = 3; cgl->dir += 3; if (cgl->dir > 3) cgl->dir -= 4;
    }
}
