#include "morpho.h"

/**************************************************/
/* dilatation par un dodecagone dans inout de taille */
/**************************************************/

int mm0_dodeca_dilate (inout, taille)
     int   taille;
     IMAGE *inout;
{
    int i, i1, i2, ret;

    GLACE *cgl, *mm0_alloc_chains();

    cgl=mm0_alloc_chains (inout);
    if(cgl==NULL) return(LACET_ALLOC_FAILED);

    ret=mm0_cont (inout, cgl);
    if(ret!=RESULTAT_OK) return(ret);
    (void)mm0_cadre (inout, 1);
    (void)mm0_cadre_int (inout, 1);

    cgl->imavide = 0; i1 = i2 = 0;
    for (i = 0; i < taille; i++) {
	if (i1 + 1 < 1.732 * i2) {
	    i1 += 1;
	    mm0_dil_chaine (cgl);
	    mm0_adjust_masque (inout, cgl, 1, 0);
	} else {
	    i2 += 1;
	    mm0_dil_chaine (cgl);
	    mm0_adjust_masque (inout, cgl, 1, 0);
	    mm0_dil_chaine_conj (cgl);
	    mm0_trace_masque (inout, cgl, 1, 2, 0);
	    mm0_copy_chaine (cgl, 2, 1);
	}
	if (cgl->imavide) return (RESULTAT_OK);
    }
    return (RESULTAT_OK);
}

int mm0_dodeca_erode (inout, taille)
     IMAGE *inout;
     int   taille;
{
    int ret;
    /*
      (de *dodeca_erode (inout taille)
      (*cxor inout 1 inout)
      (*dodeca_dilate inout taille)
      (*cxor inout 1 inout))
      */
    
    ret=mm0_calgebre(inout, 1, inout, CG_XOR);
    if(ret!=RESULTAT_OK) return(ret);
    ret=mm0_dodeca_dilate(inout, taille);
    if(ret!=RESULTAT_OK) return(ret);
    (void)mm0_calgebre(inout, 1, inout, CG_XOR);
    return(RESULTAT_OK);
}
int mm0_dodeca_open (inout, taille)
     IMAGE *inout;
     int   taille;
{
    int ret;
    /*
      (de *dodeca_open (inout taille)
      (*dodeca_erode inout taille)
      (*dodeca_dilate inout taille))
      */
    ret=mm0_dodeca_erode(inout, taille);
    if(ret!=RESULTAT_OK) return(ret);
    ret=mm0_dodeca_dilate(inout, taille);
    return(ret);
}
int mm0_dodeca_close (inout, taille)
     IMAGE *inout;
     int   taille;
{
    int ret;
    /*
      (de *dodeca_close (inout taille)
      (*dodeca_dilate inout taille)
      (*dodeca_erode inout taille))
      */
    ret=mm0_dodeca_dilate(inout, taille);
    if(ret!=RESULTAT_OK) return(ret);
    ret=mm0_dodeca_erode(inout, taille);
    return(ret);
}
