#include "morpho.h"
/* 
 * (de *bin_dilate (in out taille mode)
 *     (*calgebre in 1 out 7)
 *     (*sucero out out mode)
 *     (*thresh out out 0 (1+ taille))
 * )
 */
int	 mm0_bin_dilate ( pt_in, pt_out, size, mode)
     IMAGE *pt_in;
     IMAGE *pt_out;
     int   size, mode;		/* mode no longer used */
{
    int res;
    
    res = mm0_calgebre( pt_in, 1, pt_out, CG_XOR);
    if(res != RESULTAT_OK) return(res);

    res = mm0_sucero ( pt_out, pt_out, mode);
    if(res != RESULTAT_OK) return(res);

    res = mm0_thresh ( pt_out, pt_out, 0, (++size));
    return ( res );
}

/* 
 * (de *bin_erode (in out taille mode)
 *     (*sucero in out mode)
 *     (*thresh out out (1+ taille) 32767)
 * )
 */
int	 mm0_bin_erode ( pt_in, pt_out, size, mode)
     IMAGE *pt_in;
     IMAGE *pt_out;
     int   size, mode;		/* mode no longer used */
{
    int res;
    
    res = mm0_sucero ( pt_in, pt_out, mode);
    if(res != RESULTAT_OK) return(res);

    res = mm0_thresh ( pt_out, pt_out, (++size), PIX_MAX);
    return ( res );
}

/* (de *bin_open (in out taille mode)
 *     (*bin_erode in out taille mode)
 *     (*bin_dilate out out taille mode)
 * )
 */
int	 mm0_bin_open ( pt_in, pt_out, size, mode)
     IMAGE *pt_in;
     IMAGE *pt_out;
     int   size, mode;		/* mode no longer used */
{
    int res;
    
    res = mm0_bin_erode ( pt_in, pt_out, size, mode);
    if(res != RESULTAT_OK) return(res);

    res = mm0_bin_dilate ( pt_out, pt_out, size, mode);
    return ( res );
}

/*
 * (de *bin_close (in out taille mode)
 *     (*bin_dilate in out taille mode)
 *     (*bin_erode out out taille mode)
 * )
 */
int	 mm0_bin_close ( pt_in, pt_out, size, mode)
     IMAGE *pt_in;
     IMAGE *pt_out;
     int   size, mode;		/* mode no longer used */
{
    int res;

    res = mm0_bin_dilate ( pt_in, pt_out, size, mode);
    if(res != RESULTAT_OK) return(res);

    res = mm0_bin_erode ( pt_out, pt_out, size, mode);
    return ( res );
}
