#include "morpho.h"

int mm0_erolin (image_in, image_out, dir, mode)
     IMAGE *image_in, *image_out;
     int dir, mode;
{
    PIX *pt_in, *pt_in_old, *pt_out, *pt_out_old, *pt_vois;
    int i, j, bord, ret;
    int xmin, xmax, ymin, ymax, lincr;

    if ((ret = BASIC_CHECK (image_in)) != RESULTAT_OK) return (ret);
    if ((ret = BASIC_CHECK (image_out)) != RESULTAT_OK) return (ret);
    if ((ret = SET_SIZE (image_in,image_out)) != RESULTAT_OK) return (ret);
    if ((ret = ALLOC_X_CHECK (image_in,image_out)) != RESULTAT_OK) return (ret);

    lincr = image_in->tx;	/* both images must be allocated same */
    xmin = image_in->lx; xmax = xmin + image_in->sx;
    ymin = image_in->ly; ymax = ymin + image_in->sy;
    pt_in = image_in->bitmap  + xmin + lincr*ymin;
    pt_out= image_out->bitmap + xmin + lincr*ymin;
    
    bord = PIX_MAX; mm0_cadre (image_in, bord);
    
    dir = dir % 360;
    if (dir % 30) {
	return(CG_BAD_DIRECT);
    }
    
    /* sens video 210 <= dir <= 0=360 */
    
    for (j = ymin ; j < ymax; j++) {
	
	pt_in_old = pt_in;
	pt_out_old = pt_out;
	
	switch (dir) {
	    case   0 : pt_vois = pt_in + 1;
	    for (i = xmin ; i < xmax; i++, pt_in++, pt_vois++)
	      *pt_out++ = (*pt_in < *pt_vois) ? *pt_in : *pt_vois;
	    break;
	    case 210 : pt_vois = pt_in + lincr - 2 + (j & 1);
	    *pt_out++ = (*pt_in < bord) ? *pt_in : bord;
	    pt_in++; pt_vois++;
	    for (i = xmin ; i < xmax - 1; i++, pt_in++, pt_vois++)
	      *pt_out++ = (*pt_in < *pt_vois) ? *pt_in : *pt_vois;
	    break;
	    case 240 : pt_vois = pt_in + lincr - 1 + (j & 1);
	    for (i = xmin ; i < xmax; i++, pt_in++, pt_vois++)
	      *pt_out++ = (*pt_in < *pt_vois) ? *pt_in : *pt_vois;
	    break;
	    case 270 : pt_vois = pt_in + (lincr << 1);
	    if (j == ymax - 1)
	      for (i = xmin; i < xmax; i++, pt_in++)
		*pt_out++ = (*pt_in < bord) ? *pt_in : bord;
	    else
	      for (i = xmin ; i < xmax; i++, pt_in++, pt_vois++)
		*pt_out++ = (*pt_in < *pt_vois) ? *pt_in : *pt_vois;
	    break;
	    case 300 : pt_vois = pt_in + lincr + (j & 1);
	    for (i = xmin ; i < xmax; i++, pt_in++, pt_vois++)
	      *pt_out++ = (*pt_in < *pt_vois) ? *pt_in : *pt_vois;
	    break;
	    case 330 : pt_vois = pt_in + lincr + 1 + (j & 1);
	    for (i = xmin ; i < xmax - 1; i++, pt_in++, pt_vois++)
	      *pt_out++ = (*pt_in < *pt_vois) ? *pt_in : *pt_vois;
	    *pt_out = (*pt_in < bord) ? *pt_in : bord;
	    break;
	}
	
	pt_in = pt_in_old + lincr;
	pt_out = pt_out_old + lincr;
	
    }
    
    /* sens video inverse 30 <= dir <= 180 */
    
    
    pt_in = image_in->bitmap  + (xmax-1) + lincr*(ymax-1);
    pt_out= image_out->bitmap + (xmax-1) + lincr*(ymax-1);
    
    for (j = ymax - 1 ; j >= ymin; j--) {
	
	pt_in_old = pt_in;
	pt_out_old = pt_out;
	
	switch (dir) {
	    case  30 : pt_vois = pt_in - lincr + 1 + (j & 1);
	    *pt_out = (*pt_in < bord) ? *pt_in : bord;
	    pt_in--; pt_out--; pt_vois--;
	    for (i = xmax - 2 ; i >= xmin; i--, pt_in--, pt_vois--)
	      *pt_out-- = (*pt_in < *pt_vois) ? *pt_in : *pt_vois;
	    break;
	    case  60 : pt_vois = pt_in - lincr + (j & 1);
	    for (i = xmax - 1; i >= xmin; i--, pt_in--, pt_vois--)
	      *pt_out-- = (*pt_in < *pt_vois) ? *pt_in : *pt_vois;
	    break;
	    case  90 : pt_vois = pt_in - (lincr << 1);
	    if (j == ymin)
	      for (i = xmax-1; i >= xmin; i--, pt_in--)
		*pt_out-- = (*pt_in < bord) ? *pt_in : bord;
	    else
	      for (i = xmax - 1; i >= xmin; i--, pt_in--, pt_vois--)
		*pt_out-- = (*pt_in < *pt_vois) ? *pt_in : *pt_vois;
	    break;
	    case 120 : pt_vois = pt_in - lincr - 1 + (j & 1);
	    for (i = xmax - 1 ; i >= xmin; i--, pt_in--, pt_vois--)
	      *pt_out-- = (*pt_in < *pt_vois) ? *pt_in : *pt_vois;
	    break;
	    case 150 : pt_vois = pt_in - lincr - 2 + (j & 1);
	    for (i = xmax - 1; i >= xmin + 1; i--, pt_in--, pt_vois--)
	      *pt_out-- = (*pt_in < *pt_vois) ? *pt_in : *pt_vois;
	    *pt_out-- = (*pt_in < bord) ? *pt_in : bord;
	    break;
	    case 180 : pt_vois = pt_in - 1;
	    for (i = xmax - 1 ; i >= xmin; i--, pt_in--, pt_vois--)
	      *pt_out-- = (*pt_in < *pt_vois) ? *pt_in : *pt_vois;
	    break;
	}
	
	pt_in = pt_in_old - lincr;
	pt_out = pt_out_old - lincr;
	
    }
    
    if (mode == 1) {
	image_out->lx++; image_out->ly++;
	image_out->sx -= 2; image_out->sy -= 2;
	if (image_out->sx < 0) image_out->sx = 0;
	if (image_out->sy < 0) image_out->sy = 0;
	mm0_cadre (image_out, 0);
    }
    return (RESULTAT_OK);
}

int mm0_dillin (image_in, image_out, dir, mode)
     IMAGE *image_in, *image_out;
     int dir, mode;
{
    PIX *pt_in, *pt_in_old, *pt_out, *pt_out_old, *pt_vois;
    int i, j, bord, ret;
    int xmin, xmax, ymin, ymax, lincr;

    if ((ret = BASIC_CHECK (image_in)) != RESULTAT_OK) return (ret);
    if ((ret = BASIC_CHECK (image_out)) != RESULTAT_OK) return (ret);
    if ((ret = SET_SIZE (image_in,image_out)) != RESULTAT_OK) return (ret);
    if ((ret = ALLOC_X_CHECK (image_in,image_out)) != RESULTAT_OK) return (ret);

    lincr = image_in->tx;	/* both images must be allocated same */
    xmin = image_in->lx; xmax = xmin + image_in->sx;
    ymin = image_in->ly; ymax = ymin + image_in->sy;
    pt_in = image_in->bitmap  + xmin + lincr*ymin;
    pt_out= image_out->bitmap + xmin + lincr*ymin;

    bord = 0; mm0_cadre (image_in, bord);

    dir = dir % 360;
    if (dir % 30) {
	return(CG_BAD_DIRECT);
    }

    /* sens video 210 <= dir <= 0=360 */

    for (j = ymin ; j < ymax; j++) {

	pt_in_old = pt_in;
	pt_out_old = pt_out;

	switch (dir) {
	case   0 : pt_vois = pt_in + 1;
	    for (i = xmin ; i < xmax; i++, pt_in++, pt_vois++)
		*pt_out++ = (*pt_in > *pt_vois) ? *pt_in : *pt_vois;
	    break;
	case 210 : pt_vois = pt_in + lincr - 2 + (j & 1);
	    *pt_out++ = (*pt_in > bord) ? *pt_in : bord;
	    pt_in++; pt_vois++;
	    for (i = xmin ; i < xmax - 1; i++, pt_in++, pt_vois++)
		*pt_out++ = (*pt_in > *pt_vois) ? *pt_in : *pt_vois;
	    break;
	case 240 : pt_vois = pt_in + lincr - 1 + (j & 1);
	    for (i = xmin ; i < xmax; i++, pt_in++, pt_vois++)
		*pt_out++ = (*pt_in > *pt_vois) ? *pt_in : *pt_vois;
	    break;
	case 270 : pt_vois = pt_in + (lincr << 1);
	    if (j == ymax)
		for (i = xmin; i < xmax; i++) *pt_out++ = *pt_in++;
	    for (i = xmin ; i < xmax; i++, pt_in++, pt_vois++)
		*pt_out++ = (*pt_in > *pt_vois) ? *pt_in : *pt_vois;
	    break;
	case 300 : pt_vois = pt_in + lincr + (j & 1);
	    for (i = xmin ; i < xmax; i++, pt_in++, pt_vois++)
		*pt_out++ = (*pt_in > *pt_vois) ? *pt_in : *pt_vois;
	    break;
	case 330 : pt_vois = pt_in + lincr + 1 + (j & 1);
	    for (i = xmin ; i < xmax - 1; i++, pt_in++, pt_vois++)
		*pt_out++ = (*pt_in > *pt_vois) ? *pt_in : *pt_vois;
	    *pt_out = (*pt_in > bord) ? *pt_in : bord;
	    break;
	}
	
	pt_in = pt_in_old + lincr;
	pt_out = pt_out_old + lincr;
	
    }
    
    /* sens video inverse 30 <= dir <= 180 */
    
    
    pt_in = image_in->bitmap  + (xmax-1) + lincr*(ymax-1);
    pt_out= image_out->bitmap + (xmax-1) + lincr*(ymax-1);
    
    for (j = ymax - 1 ; j >= ymin; j--) {
	
	pt_in_old = pt_in;
	pt_out_old = pt_out;
	
	switch (dir) {
	case  30 : pt_vois = pt_in - lincr + 1 + (j & 1);
	    *pt_out = (*pt_in > bord) ? *pt_in : bord;
	    pt_in--; pt_out--; pt_vois--;
	    for (i = xmax - 2 ; i >= xmin; i--, pt_in--, pt_vois--)
		*pt_out-- = (*pt_in > *pt_vois) ? *pt_in : *pt_vois;
	    break;
	case  60 : pt_vois = pt_in - lincr + (j & 1);
	    for (i = xmax - 1; i >= xmin; i--, pt_in--, pt_vois--)
		*pt_out-- = (*pt_in > *pt_vois) ? *pt_in : *pt_vois;
	    break;
	case  90 : pt_vois = pt_in - (lincr << 1);
	    if (j == ymin)
		for (i = xmax-1; i >= xmin; i--) *pt_out-- = *pt_in--;
	    for (i = xmax - 1; i >= xmin; i--, pt_in--, pt_vois--)
		*pt_out-- = (*pt_in > *pt_vois) ? *pt_in : *pt_vois;
	    break;
	case 120 : pt_vois = pt_in - lincr - 1 + (j & 1);
	    for (i = xmax - 1 ; i >= xmin; i--, pt_in--, pt_vois--)
		*pt_out-- = (*pt_in > *pt_vois) ? *pt_in : *pt_vois;
	    break;
	case 150 : pt_vois = pt_in - lincr - 2 + (j & 1);
	    for (i = xmax - 1; i >= xmin + 1; i--, pt_in--, pt_vois--)
		*pt_out-- = (*pt_in > *pt_vois) ? *pt_in : *pt_vois;
	    *pt_out-- = (*pt_in > bord) ? *pt_in : bord;
	    break;
	case 180 : pt_vois = pt_in - 1;
	    for (i = xmax - 1 ; i >= xmin; i--, pt_in--, pt_vois--)
		*pt_out-- = (*pt_in > *pt_vois) ? *pt_in : *pt_vois;
	    break;
	}
	
	pt_in = pt_in_old - lincr;
	pt_out = pt_out_old - lincr;
	
    }
    
    if (mode == 1) {
	image_out->lx++; image_out->ly++;
	image_out->sx -= 2; image_out->sy -= 2;
	if (image_out->sx < 0) image_out->sx = 0;
	if (image_out->sy < 0) image_out->sy = 0;
	mm0_cadre (image_out, 0);
    }
    
    return (RESULTAT_OK);
}

/*
 * ;; ========= Segments ==================
 * (de *lin_dilate (in out taille dir mode)
 * (if (<= taille 0)
 * (*copy in out)
 * (_lcr_dillin in out dir mode)
 * (for (i 2 1 taille)
 * 	(_lcr_dillin out out dir mode)))
 * out)
 */

int mm0_lin_dilate( in, out, size, dir, mode)
     IMAGE *in, *out;
     int   size, dir, mode;
{
    int i, ret;
    /* checks are done by underlying codes */
    if(size <= 0) return(mm0_copy(in, out));

    ret=mm0_dillin(in, out, dir, mode);
    if(ret!=RESULTAT_OK) return(ret);
    for(i=1; i<size; i++) {
	ret=mm0_dillin(out, out, dir, mode);
	if(ret!=RESULTAT_OK) return(ret);
    }
    return(RESULTAT_OK);
}

/*
 * (de *lin_erode (in out taille dir mode)
 * (if (<= taille 0)
 * (*copy in out)
 * (_lcr_erolin in out dir mode)
 * (for (i 2 1 taille)
 * 	(_lcr_erolin out out dir mode)))
 * out)
 */

int mm0_lin_erode( in, out, size, dir, mode)
     IMAGE *in, *out;
     int   size, dir, mode;
{
    int i, ret;
    /* checks are done by underlying codes */
    if(size <= 0) return(mm0_copy(in, out));

    ret=mm0_erolin(in, out, dir, mode);
    if(ret!=RESULTAT_OK) return(ret);
    for(i=1; i<size; i++) {
	ret=mm0_erolin(out, out, dir, mode);
	if(ret!=RESULTAT_OK) return(ret);
    }
    return(RESULTAT_OK);
}
/*
 * (de *lin_close (in out taille dir mode)
 * (*lin_dilate in out taille dir 0)
 * (*lin_erode out out taille (+ 180 dir) mode))
 */
int mm0_lin_close( in, out, size, dir, mode)
     IMAGE *in, *out;
     int   size, dir, mode;
{
    int i, ret;
    /* checks are done by underlying codes */

    ret=mm0_lin_dilate(in, out, size, dir, 0);
    if(ret!=RESULTAT_OK) return(ret);
    ret=mm0_lin_erode(out, out, size, (dir + 180), mode);
    return(ret);
}
/*
 * (de *lin_open (in out taille dir mode)
 * (*lin_erode in out taille dir mode)
 * (*lin_dilate out out taille (+ 180 dir) 0))
 */
int mm0_lin_open( in, out, size, dir, mode)
     IMAGE *in, *out;
     int   size, dir, mode;
{
    int i, ret;
    /* checks are done by underlying codes */

    ret=mm0_lin_erode(in, out, size, dir, mode);
    if(ret!=RESULTAT_OK) return(ret);
    ret=mm0_lin_dilate(out, out, size, (dir + 180), 0);
    return(ret);
}
