#include "morpho.h"

int mm0_cadre (im, ival)	/* trace le cadre a` val */
     IMAGE *im;
     int   ival;
{
    PIX  c=ival, *pt, *ptend;
    int  ret;

    if ((ret = BASIC_CHECK (im)) != RESULTAT_OK) return (ret);

    pt = im->bitmap + im->lx - 1 + (im->ly - 1)*im->tx;
    ptend = pt + im->sx + 2;
    for (; pt < ptend; *pt++ = c); /* top line */

    pt = im->bitmap + im->lx -1 + (im->ly + im->sy )*im->tx;
    ptend = pt + im->sx + 2;
    for (; pt < ptend; *pt++ = c); /* bottom line */

    pt = im->bitmap + im->lx - 1 + (im->ly - 1)*im->tx;
    ptend = pt + (im->sy + 1)*im->tx;
    for (; pt < ptend; *pt = c)	pt += im->tx;

    pt = im->bitmap + im->lx + im->sx + (im->ly - 1)*im->tx;
    ptend = pt + (im->sy + 1)*im->tx;
    for (; pt < ptend; *pt = c) pt += im->tx;
    return (RESULTAT_OK);
}

/* paint the whole image to val_back, then apply frame */
int mm0_inner_frame (in, out, val_frame, val_back)
     IMAGE *in, *out;
     int   val_frame, val_back;
{
    int i, j, ret;
    int xbeg, xend, ybeg, yend;
    int xmin, xmax, ymin, ymax;
    int lincr;
    PIX  c, *pt, *pt_old;

    if ((ret = BASIC_CHECK (in )) != RESULTAT_OK) return (ret);
    if ((ret = BASIC_CHECK (out)) != RESULTAT_OK) return (ret);
    if ((ret = SET_SIZE (in,out)) != RESULTAT_OK) return (ret);

    xmin = in->lx; xmax = xmin + in->sx;
    ymin = in->ly; ymax = ymin + in->sy;
    xbeg = xmin + 1;
    xend = xmax - 1;
    ybeg = ymin + 1;
    yend = ymax - 1;

    lincr = out->tx;
    pt= out->bitmap + xmin + lincr*ymin;
    pt_old = pt;
    /* first line */
    for (i = xmin ; i < xmax; i++,  pt++) *pt = val_frame;
    pt = pt_old + lincr;
    
    for (j = ybeg ; j < yend; j++) {
	pt_old = pt;
	*pt++ = val_frame;	/* left point */
	for (i = xbeg ; i < xend; i++,  pt++)
	    *pt = val_back;
	*pt++ = val_frame;	/* right point */

	pt = pt_old + lincr;
    }
    /* last line */
    for (i = xmin ; i < xmax; i++,  pt++) *pt = val_frame;

    return (RESULTAT_OK);
}

/* trace le cadre interieur a` val */
int mm0_cadre_int (image, val)
     int   val;
     IMAGE *image;
{
    PIX  c, *pt, *ptend;
    int ret;
    
    if ((ret = BASIC_CHECK (image )) != RESULTAT_OK) return (ret);    

    c = val;
    
    pt = image->bitmap + image->lx + image->ly*image->tx;
    ptend = pt + image->sx + 1;
    for (; pt < ptend; *pt++ = c);
    
    pt = image->bitmap + image->lx + (image->ly + image->sy - 1)*image->tx;
    ptend = pt + image->sx + 1;
    for (; pt < ptend; *pt++ = c);
    
    pt = image->bitmap + image->lx + image->ly*image->tx;
    ptend = pt + (image->sy - 1)*image->tx;
    for (; pt < ptend; *pt = c) pt += image->tx;
    
    pt = image->bitmap + image->lx - 1 + image->sx + image->ly*image->tx;
    ptend = pt + (image->sy - 1)*image->tx;
    for (; pt < ptend; *pt = c) pt += image->tx;
    
    return (RESULTAT_OK);
}
