#include "morpho.h"

int mm0_clt (in1, cte, out)
IMAGE *in1, *out;
int cte;
{
  return (mm0_ccomp (in1, cte, out, CG_LT));
}

int mm0_cle (in1, cte, out)
IMAGE *in1, *out;
int cte;
{
  return (mm0_ccomp (in1, cte, out, CG_LE));
}

int mm0_ceq (in1, cte, out)
IMAGE *in1, *out;
int cte;
{
  return (mm0_ccomp (in1, cte, out, CG_EQ));
}

int mm0_cneq (in1, cte, out)
IMAGE *in1, *out;
int cte;
{
  return (mm0_ccomp (in1, cte, out, CG_NEQ));
}

int mm0_cge (in1, cte, out)
IMAGE *in1, *out;
int cte;
{
  return (mm0_ccomp (in1, cte, out, CG_GE));
}

int mm0_cgt (in1, cte, out)
IMAGE *in1, *out;
int cte;
{
  return (mm0_ccomp (in1, cte, out, CG_GT));
}

/* ---------------------------------------------------------------- */
/* op. comparaisons: in2 est une constante */
int mm0_ccomp (in1, int_in2, out, type)
     IMAGE *in1, *out;
     int type;
     int int_in2;
{
    PIX *pt_in1, *pt_in1_old, *pt_out, *pt_out_old;
    PIX pix_in2=int_in2;
    int i, j, ret;
    
    if ((ret = BASIC_CHECK (in1)) != RESULTAT_OK) return (ret);
    if ((ret = BASIC_CHECK (out)) != RESULTAT_OK) return (ret);
    if ((ret = SET_SIZE (in1,out)) != RESULTAT_OK) return (ret);
    
    pt_in1 = BEG_PIXPTR(in1);
    pt_out = BEG_PIXPTR(out);
    
    for (j = 0; j < in1->sy; j++) {
	pt_in1_old = pt_in1;
	pt_out_old = pt_out;
	switch (type)
	  {
	      default:		/* argument not in allowed range */
	      return(CG_PARAM_NOTIR);
	      
	      case CG_LT:	/* 1 */
	      for (i = 0 ; i < in1->sx; i++, pt_in1++, pt_out++)
		  *pt_out = (*pt_in1 < pix_in2) ? 1 : 0;
	      break;
	      case CG_LE:	/* 2 */
	      for (i = 0 ; i < in1->sx; i++, pt_in1++, pt_out++)
		*pt_out = (*pt_in1 <= pix_in2) ? 1 : 0;
	      break;
	      case CG_EQ:	/* 3 */
	      for (i = 0 ; i < in1->sx; i++, pt_in1++, pt_out++)
		*pt_out = (*pt_in1 == pix_in2) ? 1 : 0;
	      break;
	      case CG_NEQ:	/* 4 */
	      for (i = 0 ; i < in1->sx; i++, pt_in1++, pt_out++)
		*pt_out = (*pt_in1 != pix_in2) ? 1 : 0;
	      break;
	      case CG_GE:	/* 5 */
	      for (i = 0 ; i < in1->sx; i++, pt_in1++, pt_out++)
		*pt_out = (*pt_in1 >= pix_in2) ? 1 : 0;
	      break;
	      case CG_GT:	/* 6  */
	      for (i = 0 ; i < in1->sx; i++, pt_in1++, pt_out++)
		*pt_out = (*pt_in1 >  pix_in2) ? 1 : 0;
	      break;
	  }
	pt_in1 = pt_in1_old + in1->tx;
	pt_out = pt_out_old + out->tx;
    }
    return (RESULTAT_OK);
}
