#include "morpho.h"

/* ne calcule que l'envoloppe convexe du premier objet... */
/* enveloppe convexe forte au sens de la trame hexagonale */

int mm0_convexe_fort (inout)
     IMAGE *inout;
{
    static int dir_dep[3][6] = {
	{0,  1,  1, 0, -1, -1},
	{-1, 0,  1,  1, 0, -1},
	{-1, -1, 0,  1,  1, 0}
    };
    DIRECTION *ptend;
    int current_pos[3], conv[6];
    int i, longueur = 0;
    int ret;
    struct lacet *boucle1, *boucle2;
    GLACE  *cgl, *mm0_alloc_chains();

    cgl=mm0_alloc_chains (inout);
    if(cgl==NULL) return(LACET_ALLOC_FAILED);

    /* suivi du contour de la particule */
    ret=mm0_cont (inout, cgl);
    if(ret!=RESULTAT_OK) return(ret);

    boucle1 = cgl->loop1; boucle2 = cgl->loop2;

    /* calcul des tangentes dans les 6 directions de la trame */

    for (i = 0; i < 3; i++) {
	current_pos[i] = 0; conv[i] = 0; conv[i+3] = 0;
    }

    ptend = boucle1->liste + boucle1->longueur;
    for (cgl->pt = boucle1->liste; cgl->pt < ptend; cgl->pt++) {
	for (i = 0; i < 3; i++)	{
	    current_pos[i] += dir_dep[i][*cgl->pt];
	    if (current_pos[i] > conv[i]  ) conv[i]   = current_pos[i];
	    if (current_pos[i] < conv[i+3]) conv[i+3] = current_pos[i];
	}
    }

    for (i = 3; i < 6; i++) conv[i] = -conv[i];

    /* creation du lacet correspondant */

    boucle2->origine.x = boucle1->origine.x;
    boucle2->origine.y = boucle1->origine.y;
    boucle2->type = 1;
    cgl->pt = boucle2->liste = cgl->chain2;
    for (i = 0; i < conv[2]; i++, longueur++) *cgl->pt++ = 3;
    for (i = 0; i < conv[1] - conv[2]; i++, longueur++) *cgl->pt++ = 2;
    for (i = 0; i < conv[0] - conv[1] + conv[2]; i++, longueur++) *cgl->pt++ = 1;
    for (i = 0; i < conv[5] - conv[0] + conv[1]; i++, longueur++) *cgl->pt++ = 0;
    for (i = 0; i < conv[0] - conv[5] + conv[4]; i++, longueur++) *cgl->pt++ = 5;
    for (i = 0; i < conv[5] - conv[4]; i++, longueur++) *cgl->pt++ = 4;
    for (i = 0; i < conv[4]; i++, longueur++) *cgl->pt++ = 3;
    boucle2->longueur = longueur;

    /* remplissage des bord */

    boucle1++; boucle1->liste = NULL; boucle1--;
    boucle2++; boucle2->liste = NULL; boucle2--;
    mm0_trace_chaine (inout, cgl, 0, cgl->loop1);
    mm0_trace_chaine (inout, cgl, 1, cgl->loop2);
    mm0_copy_chaine (cgl, 1, 2);
    mm0_adjust_masque (inout, cgl, 1, 0);

    cgl->imavide = 0;
    while (cgl->imavide == 0) {
	mm0_dil_chaine (cgl);
	mm0_adjust_masque (inout, cgl, 1, 0);
    }

    return (RESULTAT_OK);
}

/* enveloppe convexe faible au sens de la trame hexagonale */

int mm0_convexe_faible (inout)
     IMAGE *inout;
{
    static int dir_dep[3][6] = {
	{0,  1,  1, 0, -1, -1},
	{-1, 0,  1,  1, 0, -1},
	{-1, -1, 0,  1,  1, 0}
    };
    DIRECTION         *ptend;
    int               current_pos[3], conv[6];
    int               i, longueur = 0, modif, dev, ret;
    PIX               *lecture;
    struct lacet *boucle1, *boucle2;
    GLACE  *cgl, *mm0_alloc_chains();

    cgl=mm0_alloc_chains (inout);
    if(cgl==NULL) return(LACET_ALLOC_FAILED);

    /* suivi du contour de la particule */
    ret=mm0_cont (inout, cgl);
    if(ret!=RESULTAT_OK) return(ret);

    boucle1 = cgl->loop1; boucle2 = cgl->loop2;
    
    /* calcul des tangentes dans les 6 directions de la trame */
    
    for (i = 0; i < 3; i++) {
	current_pos[i] = 0; conv[i] = 0; conv[i+3] = 0;
    }
    
    ptend = boucle1->liste + boucle1->longueur;
    for (cgl->pt = boucle1->liste; cgl->pt < ptend; cgl->pt++) {
	for (i = 0; i < 3; i++)	{
	    current_pos[i] += dir_dep[i][*cgl->pt];
	    if (current_pos[i] > conv[i]  ) conv[i]   = current_pos[i];
	    if (current_pos[i] < conv[i+3]) conv[i+3] = current_pos[i];
	}
    }
    
    for (i = 3; i < 6; i++) conv[i] = -conv[i];
    
    /* creation du lacet correspondant */
    
    boucle2->origine.x = boucle1->origine.x;
    boucle2->origine.y = boucle1->origine.y;
    boucle2->type = 1;
    cgl->pt = boucle2->liste = cgl->chain2;
    for (i = 0; i < conv[2]; i++, longueur++) *cgl->pt++ = 3;
    for (i = 0; i < conv[1] - conv[2]; i++, longueur++) *cgl->pt++ = 2;
    for (i = 0; i < conv[0] - conv[1] + conv[2]; i++, longueur++) *cgl->pt++ = 1;
    for (i = 0; i < conv[5] - conv[0] + conv[1]; i++, longueur++) *cgl->pt++ = 0;
    for (i = 0; i < conv[0] - conv[5] + conv[4]; i++, longueur++) *cgl->pt++ = 5;
    for (i = 0; i < conv[5] - conv[4]; i++, longueur++) *cgl->pt++ = 4;
    for (i = 0; i < conv[4]; i++, longueur++) *cgl->pt++ = 3;
    boucle2->longueur = longueur;
    
    boucle2++; boucle2->liste = NULL; --boucle2;
    
    /* lacet entourant l'enveloppe convexe faible */

    cgl->xx = cgl->loop2->origine.x; cgl->yy = cgl->loop2->origine.y;
    lecture = inout->bitmap + cgl->xx + cgl->yy*inout->tx;
    cgl->pt = cgl->loop2->liste;
    ptend = cgl->loop2->liste + cgl->loop2->longueur;
    
    modif = 1;
    while (modif) {
	cgl->xx = cgl->loop2->origine.x; cgl->yy = cgl->loop2->origine.y;
	lecture = inout->bitmap + cgl->xx + cgl->yy*inout->tx;
	cgl->pt = cgl->loop2->liste;
	cgl->dir = *cgl->pt++;
	lecture += mm0_depla (cgl, inout); mm0_xynew (cgl);
	modif = 0;
	while (cgl->pt < ptend) {
	    dev = *cgl->pt - cgl->dir; if (dev < 0) dev += 6;
	    if (dev == 5 && *lecture == 0) {
		modif = 1;
		cgl->dir = *cgl->pt; 
		lecture += mm0_depla (cgl, inout);
		mm0_xynew (cgl);
		*cgl->pt = *(cgl->pt-1);
		*(cgl->pt-1) = cgl->dir;
		cgl->dir = *cgl->pt++;
	    } else {
		cgl->dir = *cgl->pt++;
		lecture += mm0_depla (cgl, inout); mm0_xynew (cgl);
	    }
	}
    }
    
    /* remplissage des bord */
    
    boucle1++; boucle1->liste = NULL; boucle1--;
    boucle2++; boucle2->liste = NULL; boucle2--;
    mm0_trace_chaine (inout, cgl, 0, cgl->loop1);
    mm0_trace_chaine (inout, cgl, 1, cgl->loop2);
    mm0_copy_chaine (cgl, 1, 2);
    mm0_adjust_masque (inout, cgl, 1, 0);

    cgl->imavide = 0;
    while (cgl->imavide == 0) {
	mm0_dil_chaine (cgl);
	mm0_adjust_masque (inout, cgl, 1, 0);
    }
    
    return (RESULTAT_OK);
}
