#include "morpho.h"

/*  ;; ==========detection des trous==========
 *
 * (de *hole (inout out)
 *     (*cadre_interieur inout out 1 0)
 *     (*recons out (*cxor inout 1 inout))
 *     (*dif inout out out)
 *     (*cxor inout 1 inout)
 *     out)
 */

int	 mm0_hole ( inout, out)
     IMAGE *inout;
     IMAGE *out;
{
    int res;
    
    res = mm0_inner_frame( inout, out, 1, 0);
    if(res != RESULTAT_OK) return(res);
    res = mm0_calgebre( inout, 1, inout, CG_XOR);
    if(res != RESULTAT_OK) return(res);
    res = mm0_recons( out, inout);
    if(res != RESULTAT_OK) return(res);
    res = mm0_algebre( inout, out, out, CG_ANDNOT);
    if(res != RESULTAT_OK) return(res);
    res = mm0_calgebre( inout, 1, inout, CG_XOR);
    return ( res );
}

/*  ;; ==========remplissage des trous==========
 * 
 * (de *holefill (inout out)
 *     (*cadre_interieur inout out 1 0)
 *     (*recons out (*cxor inout 1 inout))
 *     (*cxor inout 1 inout)
 *     (*cxor out 1 out))
 */

int	 mm0_holefill ( inout, out)
     IMAGE *inout;
     IMAGE *out;
{
    int res;
    
    res = mm0_inner_frame( inout, out, 1, 0);
    if(res != RESULTAT_OK) return(res);
    res = mm0_calgebre( inout, 1, inout, CG_XOR);
    if(res != RESULTAT_OK) return(res);
    res = mm0_recons( out, inout);
    if(res != RESULTAT_OK) return(res);
    res = mm0_calgebre( inout, 1, inout, CG_XOR);
    if(res != RESULTAT_OK) return(res);
    res = mm0_calgebre( out, 1, out, CG_XOR);
    return ( res );
}
