#include "morpho.h"

int mm0_lt (in1, in2, out)
IMAGE *in1, *in2, *out;
{
  return (mm0_imcomp (in1, in2, out, CG_LT));
}

int mm0_le (in1, in2, out)
IMAGE *in1, *in2, *out;
{
  return (mm0_imcomp (in1, in2, out, CG_LE));
}

int mm0_eq (in1, in2, out)
IMAGE *in1, *in2, *out;
{
  return (mm0_imcomp (in1, in2, out, CG_EQ));
}

int mm0_neq (in1, in2, out)
IMAGE *in1, *in2, *out;
{
  return (mm0_imcomp (in1, in2, out, CG_NEQ));
}

int mm0_ge (in1, in2, out)
IMAGE *in1, *in2, *out;
{
  return (mm0_imcomp (in1, in2, out, CG_GE));
}

int mm0_gt (in1, in2, out)
IMAGE *in1, *in2, *out;
{
  return (mm0_imcomp (in1, in2, out, CG_GT));
}

/* comparaison pixel a pixel de deux images */
int mm0_imcomp (in1, in2, out, type)
     IMAGE *in1, *in2, *out;
     int   type;
{

    PIX *pt_in1, *pt_in1_old, *pt_in2, *pt_in2_old, *pt_out, *pt_out_old;
    int i, j, ret;
    
    if ((ret = BASIC_CHECK (in1)) != RESULTAT_OK) return (ret);
    if ((ret = BASIC_CHECK (in2)) != RESULTAT_OK) return (ret);
    if ((ret = BASIC_CHECK (out)) != RESULTAT_OK) return (ret);
    if ((ret = SIZE_CHECK (in1,in2)) != RESULTAT_OK) return (ret);
    if ((ret = SET_SIZE (in1,out)) != RESULTAT_OK) return (ret);

    pt_in1 = BEG_PIXPTR(in1);
    pt_in2 = BEG_PIXPTR(in2);
    pt_out = BEG_PIXPTR(out);
    
    for (j = 0; j < in1->sy; j++) {
	
	pt_in1_old = pt_in1;
	pt_in2_old = pt_in2;
	pt_out_old = pt_out;

	switch (type)
	  {
	      default:		/* argument not in allowed range */
	      return(CG_PARAM_NOTIR);
	      
	      case CG_LT:	/* 1 */
	      for (i = 0 ; i < in1->sx; i++, pt_in1++, pt_in2++, pt_out++)
		*pt_out = (*pt_in1 < *pt_in2) ? 1 : 0;
	      break;
	      case CG_LE:	/* 2 */
	      for (i = 0 ; i < in1->sx; i++, pt_in1++, pt_in2++, pt_out++)
		*pt_out = (*pt_in1 <= *pt_in2) ? 1 : 0;
	      break;
	      case CG_EQ:	/* 3 */
	      for (i = 0 ; i < in1->sx; i++, pt_in1++, pt_in2++, pt_out++)
		*pt_out = (*pt_in1 == *pt_in2) ? 1 : 0;
	      break;
	      case CG_NEQ:	/* 4 */
	      for (i = 0 ; i < in1->sx; i++, pt_in1++, pt_in2++, pt_out++)
		*pt_out = (*pt_in1 != *pt_in2) ? 1 : 0;
	      break;
	      case CG_GE:	/* 5 */
	      for (i = 0 ; i < in1->sx; i++, pt_in1++, pt_in2++, pt_out++)
		*pt_out = (*pt_in1 >= *pt_in2) ? 1 : 0;
	      break;
	      case CG_GT:	/* 6  */
	      for (i = 0 ; i < in1->sx; i++, pt_in1++, pt_in2++, pt_out++)
		    *pt_out = (*pt_in1 >  *pt_in2) ? 1 : 0;
	      break;
	  }
	pt_in1 = pt_in1_old + in1->tx;
	pt_in2 = pt_in2_old + in2->tx;
	pt_out = pt_out_old + out->tx;
    }
    return (RESULTAT_OK);
}
