/* beg_algo_entry

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% ipl_label
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{algorithme}
{\bf Algorithme~: \'etiquetage (label)}
\medskip
\begin{verbatim}
int ipl_label (ipl_image *ptin_inout, ipl_image **ptout_inout);
\end{verbatim}
\separ
Entr\'ee~:
	\begin{itemize}
	\item[] $I$, image binaire;
	\end{itemize} 
\centerline{/ * L'\'etiquetage est calcul\'e directement dans $I$ * /}
Sortie~:
	\begin{itemize}
	\item[] $I$, image \'etiquet\'ee;
	\end{itemize} 
\centerline{/ * Les \'etiquettes sont sup\'erieures ou \'egales \`a $2$ * /}
\separ
$i \longleftarrow 1$\\
Balayer l'image en sens vid\'eo \{
\begin{itemize}
\item[] Soit $p$ le pixel courant;
\item[] Si $I(p) = 1$ \{
	\begin{itemize}
	\item[] Cr\'eer un lacet ponctuel correspondant \`a ce pixel
	\item[] $i \longleftarrow i+1$
	\item[] Tant qu'il reste des cha\^{\i}nes ou des lacets \{
		\begin{itemize}
		\item[] Dilater les cha\^{\i}nes et lacets
		\item[] Mettre \`a jour, $Fond=1$, $Forme=i$
		\end{itemize}
	\item[] \}
	\end{itemize}
\item[] \}
\end{itemize}
\}\\
\end{algorithme}
   end_algo_entry */

#include "morpho.h"

/********************************/
/* labelling                    */
/* im : image                   */
/********************************/

int mm0_label (inout)
    IMAGE *inout;
{
    
    PIX    *pt_in, *pt_in_old;
    IMAGE  *image;
    int    x, y, etiquette = 1;
    int    xmin, xmax, ymin, ymax, ret;
    GLACE *lcrl, *mm0_alloc_chains();

    if ((ret = BASIC_CHECK (inout)) != RESULTAT_OK) return (ret);

    (void)mm0_cadre (inout, 0);	/* can't fail anymore */
    pt_in = BEG_PIXPTR(inout);
    xmin = inout->lx;
    xmax = inout->lx + inout->sx;
    ymin = inout->ly;
    ymax = ymin + inout->sy;

    lcrl=mm0_alloc_chains (inout);
    if(lcrl==NULL) return(LACET_ALLOC_FAILED);

    for (y = ymin; y < ymax; y++) {
	pt_in_old = pt_in;
	for (x = xmin; x < xmax; x++, pt_in++) {
	    if (*pt_in == 1) {
		(lcrl->loop1)->origine.x = x;
		(lcrl->loop1)->origine.y = y;
		(lcrl->loop1)->longueur = 0;
		(lcrl->loop1)->type = 1;
		(lcrl->loop1)->liste = lcrl->chain1;
		(lcrl->loop1 + 1)->liste = 0;
		*pt_in = ++etiquette; lcrl->imavide = 0;
		while (lcrl->imavide == 0) {
		    (void)mm0_dil_chaine (lcrl);
		    (void)mm0_adjust_masque (inout, lcrl, etiquette, 1);
		} 
	    }
	}
	pt_in = pt_in_old + inout->tx;
    }
    return (RESULTAT_OK);
}
