#include "morpho.h"

/*****************************************************************/
/* recherche des points de propagation de la premiere chaine     */
/*  de cg_loop1. cg_loop2 contient alors des chaines de longueur */
/*  deux pour initialiser ces point en vue de leur dilatation    */
/*****************************************************************/

void mm0_point_propa (cgl)
     GLACE *cgl;
{
    int etat = 0, i, dif;
    /* etat = 1 apres un angle de 120 degres tant que l'on continue */
    /* en ligne droite */
    struct lacet *boucle;

    boucle = cgl->loop2; cgl->pt = cgl->chain2;
    cgl->xx = cgl->loop1->origine.x;
    cgl->yy = cgl->loop1->origine.y;
    cgl->pt2 = cgl->loop1->liste;
    cgl->pt1 = cgl->loop1->liste + cgl->loop1->longueur - 1;

    for (i = 0; i <= cgl->loop1->longueur; i++) {
	if (i == cgl->loop1->longueur) cgl->pt2 = cgl->loop1->liste;
	dif = *cgl->pt2 - *cgl->pt1; if (dif < 0) dif += 6;
	if (etat == 0) {
	    switch (dif) {
		case 0 : break;
		case 1 : etat = 1;
		break;
		case 2 : (void)mm0_debut_chaine (cgl,boucle);
		boucle++;
	    	break;
		case 3 : (void)mm0_debut_chaine (cgl,boucle);
		boucle++;
		break;
		case 4 : break;
		case 5 : break;
	    }
	} else {
	    switch (dif) {
		case 0 : break;
		case 1 : (void)mm0_debut_chaine (cgl,boucle); boucle++;
		break;
		case 2 : (void)mm0_debut_chaine (cgl,boucle); boucle++;
		etat = 0; break;
		case 3 : (void)mm0_debut_chaine (cgl,boucle); boucle++;
		etat = 0; break;
		case 4 : etat = 0; break;
		case 5 : etat = 0; break;
	    }
	}
	cgl->pt1 = cgl->pt2; cgl->pt2++;
	cgl->dir = *cgl->pt1; (void)mm0_xynew (cgl);
    }
    boucle->liste = 0;
}
/***********************************************/
/* fonction de propagation de im1 dans im2     */
/* im1 doit etre binaire et simplement connexe */
/***********************************************/

int mm0_propagation (in, out)
     IMAGE *in, *out;
{
    
    PIX    *pt_im, *pt_im_old, *pt_out;
    int    x, y, i, ret;
    int    xmin, xmax, ymin, ymax;
    GLACE *cgl, *mm0_alloc_chains();

    if (in == out) return (IMAGE_NOT_DIFFERENT);

    if ((ret = BASIC_CHECK (in))  != RESULTAT_OK) return (ret);
    if ((ret = BASIC_CHECK (out)) != RESULTAT_OK) return (ret);
    if ((ret = SET_SIZE (in,out)) != RESULTAT_OK) return (ret);
    /* further check on image identity */
    pt_im = BEG_PIXPTR(in);
    pt_out = BEG_PIXPTR(out);
    if (pt_im == pt_out) return (IMAGE_NOT_DIFFERENT);

    if((ret=mm0_copy (in, out))!=RESULTAT_OK) return(ret);
    (void)mm0_cadre (in, 0);
    (void)mm0_cadre (out, 0);

    cgl=mm0_alloc_chains (in);
    if(cgl==NULL) return(LACET_ALLOC_FAILED);

    xmin = in->lx; xmax = xmin + in->sx;
    ymin = in->ly; ymax = ymin + in->sy;
    pt_im = in->bitmap + xmin + ymin*in->tx;
    
    for (y = ymin; y < ymax; y++) {
	pt_im_old = pt_im;
	for (x = xmin; x < xmax - 1; x++, pt_im++) {
	    /* recherche d'une nouvelle particule */
	    if((*pt_im == 0 && (*(pt_im + 1) & 1))
	       || (!(*pt_im & 1) && *(pt_im + 1) == 1)) {
		/* suivi du contour de la particule trouvee */
		(void )mm0_front (in, cgl, x + 1, y, 3,
				  cgl->loop1, cgl->chain1);
		/* recherche des points a propager */
		(void )mm0_point_propa (cgl);
		(void )mm0_copy_chaine (cgl, 2, 1);
		/* propagation */
		cgl->imavide = 0; i = 0;
		while (cgl->imavide == 0) {
		    i++;
		    (void )mm0_dil_chaine (cgl);
		    (void )mm0_adjust_fond (out, cgl, i, 0);
		}
	    }
	}
	pt_im = pt_im_old + in->tx;
    }
    (void)mm0_calgebre (in, (PIX)1, in, CG_AND);
    return (RESULTAT_OK);
}

/******************************************************************/
/* initialisation des chaines correspondant aux points a propager */
/******************************************************************/

void mm0_deb_ch_conj (boucle, cgl)
     struct lacet *boucle;
     GLACE  *cgl;
{
/*
    int xx_temp, yy_temp;

    dir = *cgl->pt1;
    xx_temp = xx; cgl->yy_temp = cgl->yy; cg_xynew ();
    boucle->origine.x = xx; boucle->origine.y = cgl->yy;
    boucle->longueur = 2; boucle->type = 0;
    boucle->liste = cgl->pt;
    *cgl->pt++ = (*cgl->pt1 < 3) ? *cgl->pt1 + 3 : *cgl->pt1 - 3;
    *cgl->pt++ = (*cgl->pt2 < 3) ? *cgl->pt2 + 3 : *cgl->pt2 - 3;
    cgl->xx = xx_temp; cgl->yy = yy_temp;
*/

    boucle->origine.x = cgl->xx; boucle->origine.y = cgl->yy;
    boucle->longueur = 0; boucle->type = 1;
    boucle->liste = cgl->pt;
}

/***********************************************************************/
/* recherche des points de propagation de la premiere chaine           */
/*  de cgl->loop1. cgl->loop2 contient alors des chaines de longueur */
/*  deux pour initialiser ces point en vue de leur dilatation          */
/***********************************************************************/

void mm0_point_propa_conj (cgl)
     GLACE *cgl;
{

    int etat = 0, i, dif, dir1, dir2, dif_t;
    /* etat = 1 apres un angle de 120 degres tant que l'on continue */
    /* en ligne droite */
    struct lacet *boucle;

    boucle = cgl->loop2; cgl->pt = cgl->chain2;
    cgl->xx = cgl->loop1->origine.x; cgl->yy = cgl->loop1->origine.y;
    cgl->pt2 = cgl->loop1->liste;
    cgl->pt1 = cgl->loop1->liste + cgl->loop1->longueur - 1;
    mm0_deb_ch_conj (boucle, cgl); boucle++;

    dir1 = 2*(*cgl->pt1);
    for (i = 0; i < cgl->loop1->longueur; i++) {
	dir2 = 2*(*cgl->pt2);
	dif_t = *(cgl->pt2+1) - *cgl->pt2; if (dif_t < 0) dif_t += 6;
	if (dif_t == 5) dir2 -= 1;
	if (dir2 < 0) dir2 += 12;
	dif = dir2 - dir1; if (dif < 0) dif += 12;
	if (etat == 0) {
	    switch (dif)
		{
		case 1 : etat = 1;
		    break;
		case 2 :
		case 3 :
		case 4 :
		case 5 :
		case 6 : mm0_deb_ch_conj (boucle, cgl); boucle++;
		    break;
		}
	} else {
	    switch (dif)
		{
		case 1 : mm0_deb_ch_conj (boucle, cgl); boucle++;
		    break;
		case 2 : mm0_deb_ch_conj (boucle, cgl); boucle++; etat = 0;
		    break;
		case 3 : mm0_deb_ch_conj (boucle, cgl); boucle++; etat = 0;
		    break;
		case 4 : mm0_deb_ch_conj (boucle, cgl); boucle++; etat = 0;
		    break;
		case 5 : mm0_deb_ch_conj (boucle, cgl); boucle++; etat = 0;
		    break;
		case 6 : mm0_deb_ch_conj (boucle, cgl); boucle++; etat = 0;
		    break;
		case 7 : case 8 : case 9 : case 10 : case 11 : etat = 0;
		    break;
		}
	}
	dir1 = dir2;
	cgl->dir = *cgl->pt2;
	mm0_xynew (cgl); cgl->pt2++;
	if (dif_t == 5) {
	    cgl->dir = *cgl->pt2;
	    mm0_xynew (cgl); cgl->pt2++; i++;}
    }

    boucle->liste = 0;
}

/***********************************************/
/* fonction de propagation de in dans out     */
/* in doit etre binaire et simplement connexe */
/***********************************************/
/*
\operation{(*propagation\_conj in out)}
{est identique \`a propagation, mais utilise la
m\'etrique dod\'ecagonale.}
*/

int mm0_propagation_dodeca (im_in, im_out)
     IMAGE *im_in, *im_out;
{
    PIX    *pt_im, *pt_im_old, *pt_out;
    int    x, y, i, i1, i2, ret;
    int    xmin, xmax, ymin, ymax;
    GLACE *cgl, *mm0_alloc_chains();

    if (im_in == im_out) return (IMAGE_NOT_DIFFERENT);

    if ((ret = BASIC_CHECK (im_in))  != RESULTAT_OK) return (ret);
    if ((ret = BASIC_CHECK (im_out)) != RESULTAT_OK) return (ret);
    if ((ret = SET_SIZE (im_in,im_out)) != RESULTAT_OK) return (ret);
    if ((ret = ALLOC_X_CHECK (im_in,im_out)) != RESULTAT_OK) return (ret);
    /* further check on image identity */
    pt_im = BEG_PIXPTR(im_in);
    pt_out = BEG_PIXPTR(im_out);
    if (pt_im == pt_out) return (IMAGE_NOT_DIFFERENT);
    
    cgl=mm0_alloc_chains (im_in);
    if(cgl==NULL) return(LACET_ALLOC_FAILED);

    (void)mm0_copy (im_in, im_out);
    (void)mm0_cadre (im_in, 0);
    (void)mm0_cadre (im_out, 0);

    xmin = im_in->lx; xmax = xmin + im_in->sx;
    ymin = im_in->ly; ymax = ymin + im_in->sy;
    pt_im = im_in->bitmap + xmin + ymin*im_in->tx;

    for (y = ymin; y < ymax; y++) {
	pt_im_old = pt_im;
	for (x = xmin; x < xmax - 1; x++, pt_im++) {
	    /* recherche d'une nouvelle particule */
	    if((*pt_im == 0 && (*(pt_im + 1) & 1))
	       || (!(*pt_im & 1) && *(pt_im + 1) == 1)) {
		/* suivi du contour de le particule trouvee */
		(void)mm0_front (im_in, cgl, x + 1, y, 3,
				 cgl->loop1, cgl->chain1);
		/* recherche des points a propager */
		mm0_point_propa_conj (cgl);
		mm0_copy_chaine (cgl, 2, 1);
		/* propagation */
		cgl->imavide = 0; i = i1 = i2 = 0;
		while (cgl->imavide == 0) {
		    if (i1 + 1 < 1.732 * i2) {
			i1 += 1;
			mm0_dil_chaine (cgl);
			mm0_adjust_fond (im_out, cgl, ++i, 0);
		    } else {
			i2 += 1;
			mm0_dil_chaine (cgl);
			mm0_adjust_fond (im_out, cgl, ++i, 0);
			mm0_dil_chaine_conj (cgl);
			mm0_adjust_fond (im_out, cgl, i, 0);
		    }
		}
	    }
	}
	pt_im = pt_im_old + im_in->tx;
    }
    
    (void)mm0_calgebre (im_in, 1, im_in, CG_AND);
    return (RESULTAT_OK);
}
