#include "morpho.h"

/********************************/
/* reconstruction de particule  */
/* im1 : marqueurs              */
/* im2 : masque                 */
/********************************/

int mm0_recons (image1, image2)
     IMAGE *image1, *image2;
{
    
    PIX    *pt_im1, *pt_im2, *pt_im_old1, *pt_im_old2, *pt_out;
    int    x, y, xmin, xmax, ymin, ymax, lincr;
    int    ret;
    GLACE  *lcrl, *mm0_alloc_chains();

    if (image1 == image2) return (IMAGE_NOT_DIFFERENT);

    if ((ret = BASIC_CHECK (image1))  != RESULTAT_OK) return (ret);
    if ((ret = BASIC_CHECK (image2)) != RESULTAT_OK) return (ret);
    if ((ret = SIZE_CHECK (image1,image2)) != RESULTAT_OK) return (ret);

    /* further check on image identity */
    pt_im1 = BEG_PIXPTR(image1);
    pt_out = BEG_PIXPTR(image2);
    if (pt_im1 == pt_out) return (IMAGE_NOT_DIFFERENT);

    lincr = image1->tx;
    xmin  = image1->lx; xmax = xmin + image1->sx;
    ymin  = image1->ly; ymax = ymin + image1->sy;
    pt_im1 = image1->bitmap + xmin + ymin*lincr;
    pt_im2 = image2->bitmap + xmin + ymin*lincr;

    lcrl=mm0_alloc_chains (image1);
    if(lcrl==NULL) return(LACET_ALLOC_FAILED);

    mm0_cadre(image2, 0);
    
    for (y = ymin; y < ymax; y++) {
	pt_im_old1 = pt_im1; pt_im_old2 = pt_im2;
	for (x = xmin; x < xmax; x++) {
	    if (*pt_im1 == 1 && *pt_im2 == 1) {
		lcrl->loop1->origine.x = x; lcrl->loop1->origine.y = y;
		lcrl->loop1->longueur = 0; lcrl->loop1->type = 1;
		lcrl->loop1->liste = lcrl->chain1;
		(lcrl->loop1 + 1)->liste = 0;
		*pt_im2 = 2; lcrl->imavide = 0;
		while (lcrl->imavide == 0) {
		    (void) mm0_dil_chaine (lcrl);
		    (void) mm0_adjust_masque (image2, lcrl, 2, 1);
		} 
	    }
	    pt_im1++; pt_im2++;
	}
	pt_im1 = pt_im_old1 + lincr; pt_im2 = pt_im_old2 + lincr;
    }

    (void) mm0_thresh (image2, image1, 2, 3);
    (void) mm0_thresh (image2, image2, 1, 3);
    return (RESULTAT_OK);
}
