#include "morpho.h"

mm0_reg_max (in, out)
IMAGE *in, *out;
{
  return (mm0_reg_minmax (in, out, 1));
}

mm0_reg_min (in, out)
IMAGE *in, *out;
{
  return (mm0_reg_minmax (in, out, 0));
}

/*
 *  maxima regionaux
 * 
 * (de *regmax l				; version M.Schmitt du 15/1/92
 *     (let ((in (car l)) (out (cadr l)))
 *       (*csub in 1 out)
 *       (*cmax out 0 out)
 *       (*num_dil_geod out in 0)
 *       (*sub in out out)) )
 */
int	 mm0_reg_minmax ( im_in, im_out, maxflag)
     IMAGE *im_in;
     IMAGE *im_out;
     int   maxflag;
{
    int ret;

    if(maxflag!=0) {
	ret=mm0_calgebre(im_in, 1, im_out, CG_SUB);
	if(ret!=RESULTAT_OK) return(ret);
	ret=mm0_calgebre(im_out, 0, im_out, CG_MAX);
	if(ret!=RESULTAT_OK) return(ret);
	ret=mm0_num_dil_geod(im_out, im_in, 0);
	if(ret!=RESULTAT_OK) return(ret);
	ret=mm0_algebre(im_in, im_out, im_out, CG_SUB);
    } else {
/*
 * (de *regmin l				; version M.Schmitt du 12/3/92
 *    (let ((in (car l)) (out (cadr l)))
 *       (*cadd in 1 out)
 *     (*num_ero_geod out in 32767)
 * 	(*sub out in out)))
 */
	ret=mm0_calgebre(im_in, 1, im_out, CG_ADD);
	if(ret!=RESULTAT_OK) return(ret);
	ret=mm0_num_ero_geod(im_out, im_in, PIX_MAX);
	if(ret!=RESULTAT_OK) return(ret);
	ret=mm0_algebre(im_out, im_in, im_out, CG_SUB);
    }
    return (ret);
}
